# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: api.proto
# plugin: python-betterproto
from dataclasses import dataclass
from datetime import datetime
from typing import AsyncGenerator, Dict, List, Optional

import betterproto
import grpclib

from . import common


class MarketStatus(betterproto.Enum):
    MS_UNKNOWN = 0
    MS_ONLINE = 1


class Side(betterproto.Enum):
    S_UNKNOWN = 0
    S_BID = 1
    S_ASK = 2


class OrderStatus(betterproto.Enum):
    OS_UNKNOWN = 0
    OS_OPEN = 1
    OS_PARTIAL_FILL = 2
    OS_CANCELLED = 3
    OS_FILLED = 4


class Direction(betterproto.Enum):
    D_ASCENDING = 0
    D_DESCENDING = 1


class SubmitStrategy(betterproto.Enum):
    P_UKNOWN = 0
    P_SUBMIT_ALL = 1
    P_ABORT_ON_FIRST_ERROR = 2
    P_WAIT_FOR_CONFIRMATION = 3


class Step(betterproto.Enum):
    STEP0 = 0
    STEP1 = 1
    STEP2 = 2
    STEP3 = 3


class Project(betterproto.Enum):
    P_UNKNOWN = 0
    P_ALL = 1
    P_JUPITER = 2
    P_RAYDIUM = 3
    P_SERUM = 4
    P_OPENBOOK = 5
    P_DRIFT = 6


@dataclass
class GetMarketsRequest(betterproto.Message):
    pass


@dataclass
class GetMarketsResponse(betterproto.Message):
    markets: Dict[str, "Market"] = betterproto.map_field(
        1, betterproto.TYPE_STRING, betterproto.TYPE_MESSAGE
    )


@dataclass
class Market(betterproto.Message):
    market: str = betterproto.string_field(1)
    status: "MarketStatus" = betterproto.enum_field(2)
    address: str = betterproto.string_field(3)
    base_mint: str = betterproto.string_field(4)
    quoted_mint: str = betterproto.string_field(5)
    base_decimals: int = betterproto.int64_field(6)
    quote_decimals: int = betterproto.int64_field(7)
    project: "Project" = betterproto.enum_field(8)


@dataclass
class GetTickersRequest(betterproto.Message):
    market: str = betterproto.string_field(1)
    project: "Project" = betterproto.enum_field(2)


@dataclass
class GetTickersResponse(betterproto.Message):
    tickers: List["Ticker"] = betterproto.message_field(1)


@dataclass
class Ticker(betterproto.Message):
    market: str = betterproto.string_field(1)
    market_address: str = betterproto.string_field(2)
    bid: float = betterproto.double_field(3)
    bid_size: float = betterproto.double_field(4)
    ask: float = betterproto.double_field(5)
    ask_size: float = betterproto.double_field(6)
    project: "Project" = betterproto.enum_field(7)


@dataclass
class GetKlineRequest(betterproto.Message):
    market: str = betterproto.string_field(1)
    from_: datetime = betterproto.message_field(2)
    to: datetime = betterproto.message_field(3)
    resolution: str = betterproto.string_field(4)
    limit: int = betterproto.uint32_field(5)


@dataclass
class GetKlineResponse(betterproto.Message):
    market: str = betterproto.string_field(1)
    timestamp: datetime = betterproto.message_field(2)
    candles: List["Candle"] = betterproto.message_field(3)


@dataclass
class Candle(betterproto.Message):
    start_time: datetime = betterproto.message_field(1)
    update_time: datetime = betterproto.message_field(2)
    open: float = betterproto.double_field(3)
    close: float = betterproto.double_field(4)
    low: float = betterproto.double_field(5)
    high: float = betterproto.double_field(6)
    amount: float = betterproto.double_field(7)
    volume: float = betterproto.double_field(8)
    count: float = betterproto.double_field(9)


@dataclass
class GetOrderbookRequest(betterproto.Message):
    market: str = betterproto.string_field(1)
    limit: int = betterproto.uint32_field(2)
    project: "Project" = betterproto.enum_field(3)


@dataclass
class GetOrderbooksRequest(betterproto.Message):
    markets: List[str] = betterproto.string_field(1)
    limit: int = betterproto.uint32_field(2)
    project: "Project" = betterproto.enum_field(3)


@dataclass
class GetOrderbookResponse(betterproto.Message):
    market: str = betterproto.string_field(1)
    market_address: str = betterproto.string_field(2)
    bids: List["OrderbookItem"] = betterproto.message_field(3)
    asks: List["OrderbookItem"] = betterproto.message_field(4)


@dataclass
class OrderbookItem(betterproto.Message):
    price: float = betterproto.double_field(1)
    size: float = betterproto.double_field(2)
    order_i_d: str = betterproto.string_field(3)
    client_order_i_d: int = betterproto.uint64_field(4)
    owner_address: str = betterproto.string_field(5)


@dataclass
class GetMarketDepthRequest(betterproto.Message):
    market: str = betterproto.string_field(1)
    limit: int = betterproto.uint32_field(2)
    project: "Project" = betterproto.enum_field(3)


@dataclass
class GetMarketDepthsRequest(betterproto.Message):
    markets: List[str] = betterproto.string_field(1)
    limit: int = betterproto.uint32_field(2)
    project: "Project" = betterproto.enum_field(3)


@dataclass
class GetMarketDepthResponse(betterproto.Message):
    market: str = betterproto.string_field(1)
    market_address: str = betterproto.string_field(2)
    bids: List["MarketDepthItem"] = betterproto.message_field(3)
    asks: List["MarketDepthItem"] = betterproto.message_field(4)


@dataclass
class MarketDepthItem(betterproto.Message):
    price: float = betterproto.double_field(1)
    size: float = betterproto.double_field(2)


@dataclass
class GetTradesRequest(betterproto.Message):
    market: str = betterproto.string_field(1)
    limit: int = betterproto.uint32_field(2)
    project: "Project" = betterproto.enum_field(3)


@dataclass
class GetTradesResponse(betterproto.Message):
    trades: List["Trade"] = betterproto.message_field(1)


@dataclass
class Trade(betterproto.Message):
    side: "Side" = betterproto.enum_field(1)
    size: float = betterproto.double_field(2)
    fill_price: float = betterproto.double_field(3)
    order_i_d: str = betterproto.string_field(4)
    is_maker: bool = betterproto.bool_field(5)
    address: str = betterproto.string_field(6)
    fee_or_rebate: float = betterproto.double_field(7)
    order_price: float = betterproto.double_field(8)


@dataclass
class GetServerTimeRequest(betterproto.Message):
    pass


@dataclass
class GetServerTimeResponse(betterproto.Message):
    timestamp: str = betterproto.string_field(1)


@dataclass
class GetAccountBalanceRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)


@dataclass
class GetAccountBalanceResponse(betterproto.Message):
    tokens: List["TokenBalance"] = betterproto.message_field(1)


@dataclass
class TokenBalance(betterproto.Message):
    symbol: str = betterproto.string_field(1)
    token_mint: str = betterproto.string_field(2)
    settled_amount: float = betterproto.double_field(3)
    unsettled_amount: float = betterproto.double_field(4)
    open_orders_amount: float = betterproto.double_field(5)


@dataclass
class GetTokenAccountsRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)


@dataclass
class GetTokenAccountsResponse(betterproto.Message):
    accounts: List["TokenAccount"] = betterproto.message_field(1)


@dataclass
class TokenAccount(betterproto.Message):
    symbol: str = betterproto.string_field(1)
    token_mint: str = betterproto.string_field(2)
    token_account: str = betterproto.string_field(3)
    amount: float = betterproto.double_field(4)


@dataclass
class PostOrderRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    payer_address: str = betterproto.string_field(2)
    market: str = betterproto.string_field(3)
    side: "Side" = betterproto.enum_field(4)
    type: List[common.OrderType] = betterproto.enum_field(5)
    amount: float = betterproto.double_field(6)
    price: float = betterproto.double_field(7)
    open_orders_address: str = betterproto.string_field(8)
    client_order_i_d: int = betterproto.uint64_field(9)
    project: "Project" = betterproto.enum_field(10)


@dataclass
class PostReplaceOrderRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    payer_address: str = betterproto.string_field(2)
    market: str = betterproto.string_field(3)
    side: "Side" = betterproto.enum_field(4)
    type: List[common.OrderType] = betterproto.enum_field(5)
    amount: float = betterproto.double_field(6)
    price: float = betterproto.double_field(7)
    open_orders_address: str = betterproto.string_field(8)
    client_order_i_d: int = betterproto.uint64_field(9)
    order_i_d: str = betterproto.string_field(10)
    project: "Project" = betterproto.enum_field(11)


@dataclass
class PostOrderResponse(betterproto.Message):
    transaction: "TransactionMessage" = betterproto.message_field(1)
    open_orders_address: str = betterproto.string_field(2)


@dataclass
class PostCancelOrderRequest(betterproto.Message):
    order_i_d: str = betterproto.string_field(1)
    side: "Side" = betterproto.enum_field(2)
    market_address: str = betterproto.string_field(3)
    owner_address: str = betterproto.string_field(4)
    open_orders_address: str = betterproto.string_field(5)
    project: "Project" = betterproto.enum_field(6)


@dataclass
class PostCancelByClientOrderIDRequest(betterproto.Message):
    client_order_i_d: int = betterproto.uint64_field(1)
    market_address: str = betterproto.string_field(2)
    owner_address: str = betterproto.string_field(3)
    open_orders_address: str = betterproto.string_field(4)
    project: "Project" = betterproto.enum_field(5)


@dataclass
class PostCancelOrderResponse(betterproto.Message):
    transaction: "TransactionMessage" = betterproto.message_field(1)


@dataclass
class PostCancelAllRequest(betterproto.Message):
    market: str = betterproto.string_field(1)
    owner_address: str = betterproto.string_field(2)
    open_orders_addresses: List[str] = betterproto.string_field(3)
    project: "Project" = betterproto.enum_field(4)


@dataclass
class TransactionMessage(betterproto.Message):
    content: str = betterproto.string_field(1)
    is_cleanup: bool = betterproto.bool_field(2)


@dataclass
class PostCancelAllResponse(betterproto.Message):
    transactions: List["TransactionMessage"] = betterproto.message_field(1)


@dataclass
class PostSettleRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    market: str = betterproto.string_field(2)
    base_token_wallet: str = betterproto.string_field(3)
    quote_token_wallet: str = betterproto.string_field(4)
    open_orders_address: str = betterproto.string_field(5)
    project: "Project" = betterproto.enum_field(6)


@dataclass
class PostSettleResponse(betterproto.Message):
    transaction: "TransactionMessage" = betterproto.message_field(1)


@dataclass
class Settlement(betterproto.Message):
    symbol: str = betterproto.string_field(1)
    unsettled: float = betterproto.double_field(2)
    amount: float = betterproto.double_field(3)


@dataclass
class GetOrdersRequest(betterproto.Message):
    market: str = betterproto.string_field(1)
    status: "OrderStatus" = betterproto.enum_field(2)
    side: "Side" = betterproto.enum_field(3)
    types: List[common.OrderType] = betterproto.enum_field(4)
    from_: datetime = betterproto.message_field(5)
    limit: int = betterproto.uint32_field(6)
    direction: "Direction" = betterproto.enum_field(7)
    address: str = betterproto.string_field(8)
    open_orders_address: str = betterproto.string_field(9)
    project: "Project" = betterproto.enum_field(10)


@dataclass
class GetOrdersResponse(betterproto.Message):
    orders: List["Order"] = betterproto.message_field(1)


@dataclass
class Order(betterproto.Message):
    order_i_d: str = betterproto.string_field(1)
    market: str = betterproto.string_field(2)
    side: "Side" = betterproto.enum_field(3)
    types: List[common.OrderType] = betterproto.enum_field(4)
    price: float = betterproto.double_field(5)
    remaining_size: float = betterproto.double_field(6)
    created_at: datetime = betterproto.message_field(7)
    client_order_i_d: str = betterproto.string_field(8)
    open_order_account: str = betterproto.string_field(9)


@dataclass
class GetOrderStatusStreamRequest(betterproto.Message):
    market: str = betterproto.string_field(1)
    owner_address: str = betterproto.string_field(2)
    project: "Project" = betterproto.enum_field(3)


@dataclass
class GetOrderStatusStreamResponse(betterproto.Message):
    slot: int = betterproto.int64_field(1)
    order_info: "GetOrderStatusResponse" = betterproto.message_field(2)


@dataclass
class GetOrderStatusResponse(betterproto.Message):
    market: str = betterproto.string_field(1)
    open_order_address: str = betterproto.string_field(2)
    order_i_d: str = betterproto.string_field(3)
    client_order_i_d: int = betterproto.uint64_field(4)
    quantity_released: float = betterproto.float_field(5)
    quantity_remaining: float = betterproto.float_field(6)
    fill_price: float = betterproto.float_field(7)
    side: "Side" = betterproto.enum_field(8)
    order_status: "OrderStatus" = betterproto.enum_field(9)
    order_price: float = betterproto.float_field(10)


@dataclass
class PostSubmitRequest(betterproto.Message):
    transaction: "TransactionMessage" = betterproto.message_field(1)
    skip_pre_flight: bool = betterproto.bool_field(2)


@dataclass
class PostSubmitRequestEntry(betterproto.Message):
    transaction: "TransactionMessage" = betterproto.message_field(1)
    skip_pre_flight: bool = betterproto.bool_field(2)


@dataclass
class PostSubmitBatchRequest(betterproto.Message):
    entries: List["PostSubmitRequestEntry"] = betterproto.message_field(1)
    submit_strategy: "SubmitStrategy" = betterproto.enum_field(2)


@dataclass
class PostSubmitResponse(betterproto.Message):
    signature: str = betterproto.string_field(1)


@dataclass
class PostSubmitBatchResponseEntry(betterproto.Message):
    signature: str = betterproto.string_field(1)
    error: str = betterproto.string_field(2)
    submitted: bool = betterproto.bool_field(3)


@dataclass
class PostSubmitBatchResponse(betterproto.Message):
    transactions: List["PostSubmitBatchResponseEntry"] = betterproto.message_field(1)


@dataclass
class GetOpenOrdersRequest(betterproto.Message):
    market: str = betterproto.string_field(1)
    limit: int = betterproto.uint32_field(2)
    address: str = betterproto.string_field(3)
    open_orders_address: str = betterproto.string_field(4)
    project: "Project" = betterproto.enum_field(5)


@dataclass
class GetOpenOrdersResponse(betterproto.Message):
    orders: List["Order"] = betterproto.message_field(1)


@dataclass
class GetOrderByIDRequest(betterproto.Message):
    order_i_d: str = betterproto.string_field(1)
    market: str = betterproto.string_field(2)
    project: "Project" = betterproto.enum_field(3)


@dataclass
class GetOrderByIDResponse(betterproto.Message):
    order: "Order" = betterproto.message_field(1)


@dataclass
class GetUnsettledRequest(betterproto.Message):
    market: str = betterproto.string_field(1)
    owner_address: str = betterproto.string_field(2)
    project: "Project" = betterproto.enum_field(3)


@dataclass
class UnsettledAccountToken(betterproto.Message):
    address: str = betterproto.string_field(1)
    amount: float = betterproto.double_field(2)


@dataclass
class UnsettledAccount(betterproto.Message):
    account: str = betterproto.string_field(1)
    base_token: "UnsettledAccountToken" = betterproto.message_field(2)
    quote_token: "UnsettledAccountToken" = betterproto.message_field(3)


@dataclass
class GetUnsettledResponse(betterproto.Message):
    market: str = betterproto.string_field(1)
    unsettled: List["UnsettledAccount"] = betterproto.message_field(2)


@dataclass
class GetOrderbooksStreamResponse(betterproto.Message):
    slot: int = betterproto.int64_field(1)
    orderbook: "GetOrderbookResponse" = betterproto.message_field(2)


@dataclass
class GetMarketDepthsStreamResponse(betterproto.Message):
    slot: int = betterproto.int64_field(1)
    data: "GetMarketDepthResponse" = betterproto.message_field(2)


@dataclass
class GetTickersStreamResponse(betterproto.Message):
    slot: int = betterproto.int64_field(1)
    ticker: "GetTickersResponse" = betterproto.message_field(2)


@dataclass
class GetTradesStreamResponse(betterproto.Message):
    slot: int = betterproto.int64_field(1)
    trades: "GetTradesResponse" = betterproto.message_field(2)


@dataclass
class GetQuotesRequest(betterproto.Message):
    in_token: str = betterproto.string_field(1)
    out_token: str = betterproto.string_field(2)
    in_amount: float = betterproto.double_field(3)
    slippage: float = betterproto.double_field(4)
    limit: int = betterproto.int32_field(5)
    projects: List["Project"] = betterproto.enum_field(6)


@dataclass
class GetQuotesResponse(betterproto.Message):
    in_token: str = betterproto.string_field(1)
    in_token_address: str = betterproto.string_field(2)
    out_token: str = betterproto.string_field(3)
    out_token_address: str = betterproto.string_field(4)
    in_amount: float = betterproto.double_field(5)
    quotes: List["ProjectQuote"] = betterproto.message_field(6)


@dataclass
class ProjectQuote(betterproto.Message):
    project: "Project" = betterproto.enum_field(1)
    routes: List["QuoteRoute"] = betterproto.message_field(2)


@dataclass
class TradeSwapRequest(betterproto.Message):
    project: "Project" = betterproto.enum_field(1)
    owner_address: str = betterproto.string_field(2)
    in_token: str = betterproto.string_field(3)
    out_token: str = betterproto.string_field(4)
    in_amount: float = betterproto.double_field(5)
    slippage: float = betterproto.double_field(6)


@dataclass
class RouteTradeSwapRequest(betterproto.Message):
    project: "Project" = betterproto.enum_field(1)
    owner_address: str = betterproto.string_field(2)
    steps: List["RouteStep"] = betterproto.message_field(3)


@dataclass
class RouteStep(betterproto.Message):
    in_token: str = betterproto.string_field(1)
    in_amount: float = betterproto.double_field(2)
    out_token: str = betterproto.string_field(3)
    out_amount: float = betterproto.double_field(4)
    out_amount_min: float = betterproto.double_field(5)
    project: "StepProject" = betterproto.message_field(6)


@dataclass
class TradeSwapResponse(betterproto.Message):
    project: "Project" = betterproto.enum_field(1)
    transactions: List["TransactionMessage"] = betterproto.message_field(2)
    out_amount: float = betterproto.double_field(3)
    out_amount_min: float = betterproto.double_field(4)
    price_impact: common.PriceImpactPercent = betterproto.message_field(5)
    fees: List[common.Fee] = betterproto.message_field(6)


@dataclass
class QuoteRoute(betterproto.Message):
    in_amount: float = betterproto.double_field(1)
    out_amount: float = betterproto.double_field(2)
    out_amount_min: float = betterproto.double_field(3)
    steps: List["QuoteStep"] = betterproto.message_field(4)


@dataclass
class QuoteStep(betterproto.Message):
    project: "StepProject" = betterproto.message_field(1)
    in_token: str = betterproto.string_field(2)
    in_token_address: str = betterproto.string_field(3)
    out_token: str = betterproto.string_field(4)
    out_token_address: str = betterproto.string_field(5)
    in_amount: float = betterproto.double_field(6)
    out_amount: float = betterproto.double_field(7)
    slippage: float = betterproto.double_field(8)
    price_impact_percent: common.PriceImpactPercent = betterproto.message_field(9)
    fee: common.Fee = betterproto.message_field(10)
    out_amount_min: float = betterproto.double_field(11)


@dataclass
class StepProject(betterproto.Message):
    label: str = betterproto.string_field(1)
    id: str = betterproto.string_field(2)


@dataclass
class GetRecentBlockHashRequest(betterproto.Message):
    pass


@dataclass
class GetRecentBlockHashResponse(betterproto.Message):
    block_hash: str = betterproto.string_field(1)


@dataclass
class Block(betterproto.Message):
    slot: int = betterproto.uint64_field(1)
    hash: str = betterproto.string_field(2)
    time: int = betterproto.int64_field(3)
    height: int = betterproto.uint64_field(4)


@dataclass
class GetBlockStreamRequest(betterproto.Message):
    pass


@dataclass
class GetBlockStreamResponse(betterproto.Message):
    block: "Block" = betterproto.message_field(1)


@dataclass
class GetPoolsRequest(betterproto.Message):
    projects: List["Project"] = betterproto.enum_field(1)


@dataclass
class GetPoolsResponse(betterproto.Message):
    projects: List["ProjectPools"] = betterproto.message_field(1)


@dataclass
class ProjectPools(betterproto.Message):
    project: "Project" = betterproto.enum_field(1)
    pools: List["ProjectPool"] = betterproto.message_field(2)


@dataclass
class ProjectPool(betterproto.Message):
    pool: str = betterproto.string_field(1)
    pool_address: str = betterproto.string_field(2)
    token1_reserves: int = betterproto.int64_field(3)
    token1_mint_address: str = betterproto.string_field(4)
    token1_mint_symbol: str = betterproto.string_field(5)
    token2_reserves: int = betterproto.int64_field(6)
    token2_mint_address: str = betterproto.string_field(7)
    token2_mint_symbol: str = betterproto.string_field(8)


@dataclass
class GetQuotesStreamRequest(betterproto.Message):
    projects: List["Project"] = betterproto.enum_field(1)
    token_pairs: List["TokenPair"] = betterproto.message_field(2)


@dataclass
class GetQuotesStreamResponse(betterproto.Message):
    slot: int = betterproto.int64_field(1)
    quote: "GetQuotesStreamUpdate" = betterproto.message_field(2)


@dataclass
class GetQuotesStreamUpdate(betterproto.Message):
    in_token: str = betterproto.string_field(1)
    in_token_address: str = betterproto.string_field(2)
    out_token: str = betterproto.string_field(3)
    out_token_address: str = betterproto.string_field(4)
    in_amount: float = betterproto.double_field(5)
    out_amount: float = betterproto.double_field(6)
    project: "Project" = betterproto.enum_field(7)


@dataclass
class GetSwapsStreamRequest(betterproto.Message):
    projects: List["Project"] = betterproto.enum_field(1)
    pools: List[str] = betterproto.string_field(2)
    include_failed: bool = betterproto.bool_field(3)


@dataclass
class GetSwapsStreamResponse(betterproto.Message):
    slot: int = betterproto.int64_field(1)
    swap: "GetSwapsStreamUpdate" = betterproto.message_field(2)


@dataclass
class GetSwapsStreamUpdate(betterproto.Message):
    success: bool = betterproto.bool_field(1)
    project: "Project" = betterproto.enum_field(2)
    pool_address: str = betterproto.string_field(3)
    in_token: str = betterproto.string_field(4)
    in_token_address: str = betterproto.string_field(5)
    out_token: str = betterproto.string_field(6)
    out_token_address: str = betterproto.string_field(7)
    in_amount: float = betterproto.double_field(8)
    out_amount_min: float = betterproto.double_field(9)
    source_account: str = betterproto.string_field(10)
    destination_account: str = betterproto.string_field(11)
    owner_account: str = betterproto.string_field(12)
    signature: str = betterproto.string_field(13)


@dataclass
class TokenPair(betterproto.Message):
    in_token: str = betterproto.string_field(1)
    out_token: str = betterproto.string_field(2)
    in_amount: float = betterproto.double_field(3)


@dataclass
class GetPriceRequest(betterproto.Message):
    tokens: List[str] = betterproto.string_field(1)


@dataclass
class GetPriceResponse(betterproto.Message):
    token_prices: List["TokenPrice"] = betterproto.message_field(1)


@dataclass
class TokenPrice(betterproto.Message):
    token: str = betterproto.string_field(1)
    token_address: str = betterproto.string_field(2)
    project: "Project" = betterproto.enum_field(3)
    buy: float = betterproto.double_field(4)
    buy_size: float = betterproto.double_field(5)
    sell: float = betterproto.double_field(6)
    sell_size: float = betterproto.double_field(7)


@dataclass
class GetPoolReservesStreamResponse(betterproto.Message):
    slot: int = betterproto.int64_field(1)
    reserves: "PoolReserves" = betterproto.message_field(2)


@dataclass
class PoolReserves(betterproto.Message):
    token1_reserves: str = betterproto.string_field(1)
    token1_address: str = betterproto.string_field(2)
    token2_reserves: str = betterproto.string_field(3)
    token2_address: str = betterproto.string_field(4)
    pool_address: str = betterproto.string_field(5)
    project: "Project" = betterproto.enum_field(6)


@dataclass
class GetPoolReservesStreamRequest(betterproto.Message):
    projects: List["Project"] = betterproto.enum_field(1)


@dataclass
class GetPricesStreamRequest(betterproto.Message):
    projects: List["Project"] = betterproto.enum_field(1)
    tokens: List[str] = betterproto.string_field(2)


@dataclass
class GetPricesStreamResponse(betterproto.Message):
    slot: int = betterproto.int64_field(1)
    price: "TokenPrice" = betterproto.message_field(2)


@dataclass
class GetPerpOrderbookRequest(betterproto.Message):
    """Drift messages"""

    market: str = betterproto.string_field(1)
    limit: int = betterproto.uint32_field(2)
    project: "Project" = betterproto.enum_field(3)


@dataclass
class GetPerpOrderbooksRequest(betterproto.Message):
    markets: List[str] = betterproto.string_field(1)
    limit: int = betterproto.uint32_field(2)
    project: "Project" = betterproto.enum_field(3)


@dataclass
class GetPerpOrderbookResponse(betterproto.Message):
    market: str = betterproto.string_field(1)
    market_index: int = betterproto.int32_field(2)
    bids: List["PerpOrderbookItem"] = betterproto.message_field(3)
    asks: List["PerpOrderbookItem"] = betterproto.message_field(4)


@dataclass
class PerpOrderbookItem(betterproto.Message):
    price: float = betterproto.double_field(1)
    size: float = betterproto.double_field(2)
    order_i_d: str = betterproto.string_field(3)
    client_order_i_d: str = betterproto.string_field(4)
    status: str = betterproto.string_field(5)
    order_type: str = betterproto.string_field(6)
    slot: int = betterproto.int64_field(7)
    reduce_only: bool = betterproto.bool_field(8)
    trigger_price: float = betterproto.double_field(9)
    trigger_condition: str = betterproto.string_field(10)
    post_only: bool = betterproto.bool_field(11)
    oracle_price_offset: float = betterproto.double_field(12)
    auction_duration: int = betterproto.int32_field(13)
    auction_start_price: float = betterproto.double_field(14)
    auction_end_price: float = betterproto.double_field(15)


@dataclass
class GetPerpOrderbooksStreamResponse(betterproto.Message):
    slot: int = betterproto.int64_field(1)
    orderbook: "GetPerpOrderbookResponse" = betterproto.message_field(2)


@dataclass
class GetUserRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    project: "Project" = betterproto.enum_field(2)


@dataclass
class GetUserResponse(betterproto.Message):
    status: str = betterproto.string_field(1)
    account_number: int = betterproto.int64_field(2)
    account_address: str = betterproto.string_field(3)
    project: "Project" = betterproto.enum_field(4)


@dataclass
class PostCreateUserRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    project: "Project" = betterproto.enum_field(2)


@dataclass
class PostCreateUserResponse(betterproto.Message):
    transaction: "TransactionMessage" = betterproto.message_field(1)
    project: "Project" = betterproto.enum_field(2)


@dataclass
class PostCancelPerpOrdersRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    project: "Project" = betterproto.enum_field(2)
    contract: common.PerpContract = betterproto.enum_field(3)
    account_address: str = betterproto.string_field(4)


@dataclass
class PostCancelPerpOrdersResponse(betterproto.Message):
    transaction: "TransactionMessage" = betterproto.message_field(1)


@dataclass
class PostCancelPerpOrderRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    project: "Project" = betterproto.enum_field(2)
    contract: common.PerpContract = betterproto.enum_field(3)
    client_order_i_d: int = betterproto.uint64_field(4)
    order_i_d: int = betterproto.uint64_field(5)
    account_address: str = betterproto.string_field(6)


@dataclass
class PostCancelPerpOrderResponse(betterproto.Message):
    transaction: "TransactionMessage" = betterproto.message_field(1)


@dataclass
class PostManageCollateralRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    account_address: str = betterproto.string_field(2)
    amount: float = betterproto.double_field(3)
    project: "Project" = betterproto.enum_field(4)
    type: common.PerpCollateralType = betterproto.enum_field(5)
    token: common.PerpCollateralToken = betterproto.enum_field(6)


@dataclass
class PostManageCollateralResponse(betterproto.Message):
    transaction: "TransactionMessage" = betterproto.message_field(1)


@dataclass
class GetOpenPerpOrdersRequest(betterproto.Message):
    project: "Project" = betterproto.enum_field(1)
    owner_address: str = betterproto.string_field(2)
    account_address: str = betterproto.string_field(3)
    contracts: List[common.PerpContract] = betterproto.enum_field(4)


@dataclass
class GetOpenPerpOrdersResponse(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    account_address: str = betterproto.string_field(2)
    orders: List["PerpOrder"] = betterproto.message_field(3)


@dataclass
class PerpOrder(betterproto.Message):
    order_i_d: int = betterproto.uint64_field(1)
    client_order_i_d: int = betterproto.uint64_field(2)
    contract: common.PerpContract = betterproto.enum_field(3)
    position_side: common.PerpPositionSide = betterproto.enum_field(4)
    order_type: str = betterproto.string_field(5)
    unrealized_pn_l: float = betterproto.double_field(6)
    price: float = betterproto.double_field(7)
    size: float = betterproto.double_field(8)
    remaining_size: float = betterproto.double_field(9)
    status: str = betterproto.string_field(10)


@dataclass
class GetPerpPositionsRequest(betterproto.Message):
    project: "Project" = betterproto.enum_field(1)
    owner_address: str = betterproto.string_field(2)
    account_address: str = betterproto.string_field(3)
    contracts: List[common.PerpContract] = betterproto.enum_field(4)


@dataclass
class GetPerpPositionsResponse(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    account_address: str = betterproto.string_field(2)
    perp_positions: List["PerpPosition"] = betterproto.message_field(3)


@dataclass
class PostClosePerpPositionsRequest(betterproto.Message):
    project: "Project" = betterproto.enum_field(1)
    owner_address: str = betterproto.string_field(2)
    contracts: List[common.PerpContract] = betterproto.enum_field(3)


@dataclass
class PostClosePerpPositionsResponse(betterproto.Message):
    transactions: List["TransactionMessage"] = betterproto.message_field(1)


@dataclass
class PerpPosition(betterproto.Message):
    contract: common.PerpContract = betterproto.enum_field(1)
    contract_volume: float = betterproto.double_field(2)
    volume_available: float = betterproto.double_field(3)
    volume_in_order: float = betterproto.double_field(4)
    position_margin: float = betterproto.double_field(5)
    position_side: common.PerpPositionSide = betterproto.enum_field(6)
    unrealized_pn_l: float = betterproto.double_field(7)
    notional_value: float = betterproto.double_field(8)
    index_price: float = betterproto.double_field(9)
    liquidation_price: float = betterproto.double_field(10)


@dataclass
class PostPerpOrderRequest(betterproto.Message):
    project: "Project" = betterproto.enum_field(1)
    owner_address: str = betterproto.string_field(2)
    payer_address: str = betterproto.string_field(3)
    contract: common.PerpContract = betterproto.enum_field(4)
    account_address: str = betterproto.string_field(5)
    position_side: common.PerpPositionSide = betterproto.enum_field(6)
    slippage: float = betterproto.double_field(7)
    type: common.PerpOrderType = betterproto.enum_field(8)
    amount: float = betterproto.double_field(9)
    price: float = betterproto.double_field(10)
    client_order_i_d: int = betterproto.uint64_field(11)


@dataclass
class PostPerpOrderResponse(betterproto.Message):
    transaction: "TransactionMessage" = betterproto.message_field(1)


@dataclass
class GetNewPerpOrdersStreamRequest(betterproto.Message):
    markets: List[str] = betterproto.string_field(1)
    project: "Project" = betterproto.enum_field(3)


@dataclass
class GetNewPerpOrdersStreamResponse(betterproto.Message):
    market: str = betterproto.string_field(1)
    market_index: int = betterproto.int32_field(2)
    side: common.PerpPositionSide = betterproto.enum_field(3)
    type: common.PerpOrderType = betterproto.enum_field(4)
    user_address: str = betterproto.string_field(5)
    order_i_d: str = betterproto.string_field(6)
    client_order_i_d: str = betterproto.string_field(7)
    slot: str = betterproto.string_field(8)
    price: float = betterproto.double_field(9)
    trigger_price: float = betterproto.double_field(10)
    base_amount: float = betterproto.double_field(11)
    base_amount_filled: float = betterproto.double_field(12)
    quote_amount: float = betterproto.double_field(13)
    quote_amount_filled: float = betterproto.double_field(14)


@dataclass
class GetPerpTradesStreamRequest(betterproto.Message):
    markets: List[str] = betterproto.string_field(1)
    address: str = betterproto.string_field(2)
    project: "Project" = betterproto.enum_field(3)


@dataclass
class GetPerpTradesStreamResponse(betterproto.Message):
    market: str = betterproto.string_field(1)
    market_index: int = betterproto.int32_field(2)
    maker_position_side: common.PerpPositionSide = betterproto.enum_field(3)
    filler_address: str = betterproto.string_field(4)
    taker_address: str = betterproto.string_field(5)
    taker_order_i_d: str = betterproto.string_field(6)
    maker_address: str = betterproto.string_field(7)
    maker_order_i_d: str = betterproto.string_field(8)
    base_amount_filled: float = betterproto.double_field(9)
    quote_amount_filled: float = betterproto.double_field(10)


@dataclass
class PostSettlePNLRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    settlee_account_address: str = betterproto.string_field(2)
    contract: common.PerpContract = betterproto.enum_field(3)
    project: "Project" = betterproto.enum_field(4)


@dataclass
class PostSettlePNLResponse(betterproto.Message):
    transaction: "TransactionMessage" = betterproto.message_field(1)


@dataclass
class GetAssetsRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    account_address: str = betterproto.string_field(2)
    contract: common.PerpContract = betterproto.enum_field(3)
    project: "Project" = betterproto.enum_field(4)


@dataclass
class Asset(betterproto.Message):
    valuation_asset: str = betterproto.string_field(1)
    balance: float = betterproto.double_field(2)
    valuation: float = betterproto.double_field(3)


@dataclass
class GetAssetsResponse(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    account_address: str = betterproto.string_field(2)
    assets: List["Asset"] = betterproto.message_field(3)


@dataclass
class PostSettlePNLsRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    settlee_account_addresses: List[str] = betterproto.string_field(2)
    contract: common.PerpContract = betterproto.enum_field(3)
    project: "Project" = betterproto.enum_field(4)


@dataclass
class PostSettlePNLsResponse(betterproto.Message):
    transactions: List["TransactionMessage"] = betterproto.message_field(1)


@dataclass
class PostLiquidatePerpRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    settlee_account_address: str = betterproto.string_field(2)
    contract: common.PerpContract = betterproto.enum_field(3)
    amount: float = betterproto.double_field(4)
    project: "Project" = betterproto.enum_field(5)


@dataclass
class PostLiquidatePerpResponse(betterproto.Message):
    transaction: "TransactionMessage" = betterproto.message_field(1)


@dataclass
class GetPerpContractsRequest(betterproto.Message):
    contracts: List[common.PerpContract] = betterproto.enum_field(1)
    project: "Project" = betterproto.enum_field(2)


@dataclass
class ContractInfo(betterproto.Message):
    contract: common.PerpContract = betterproto.enum_field(1)
    contract_address: str = betterproto.string_field(2)
    open_long_interest: float = betterproto.double_field(3)
    open_short_interest: float = betterproto.double_field(4)
    funding_rate: float = betterproto.double_field(5)
    min_size: float = betterproto.double_field(6)
    perp_price: float = betterproto.double_field(7)
    index_price: float = betterproto.double_field(8)


@dataclass
class GetPerpContractsResponse(betterproto.Message):
    contracts: List["ContractInfo"] = betterproto.message_field(1)


@dataclass
class GetOpenPerpOrderRequest(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    account_address: str = betterproto.string_field(2)
    contract: common.PerpContract = betterproto.enum_field(3)
    order_i_d: int = betterproto.uint64_field(4)
    client_order_i_d: int = betterproto.uint64_field(5)
    project: "Project" = betterproto.enum_field(6)


@dataclass
class GetOpenPerpOrderResponse(betterproto.Message):
    owner_address: str = betterproto.string_field(1)
    account_address: str = betterproto.string_field(2)
    order: "PerpOrder" = betterproto.message_field(3)


class ApiStub(betterproto.ServiceStub):
    async def get_price(self, *, tokens: List[str] = []) -> GetPriceResponse:
        request = GetPriceRequest()
        request.tokens = tokens

        return await self._unary_unary(
            "/api.Api/GetPrice",
            request,
            GetPriceResponse,
        )

    async def get_markets(self) -> GetMarketsResponse:
        request = GetMarketsRequest()

        return await self._unary_unary(
            "/api.Api/GetMarkets",
            request,
            GetMarketsResponse,
        )

    async def get_pools(self, *, projects: List["Project"] = []) -> GetPoolsResponse:
        request = GetPoolsRequest()
        request.projects = projects

        return await self._unary_unary(
            "/api.Api/GetPools",
            request,
            GetPoolsResponse,
        )

    async def get_tickers(
        self, *, market: str = "", project: "Project" = 0
    ) -> GetTickersResponse:
        request = GetTickersRequest()
        request.market = market
        request.project = project

        return await self._unary_unary(
            "/api.Api/GetTickers",
            request,
            GetTickersResponse,
        )

    async def get_kline(
        self,
        *,
        market: str = "",
        from_: Optional[datetime] = None,
        to: Optional[datetime] = None,
        resolution: str = "",
        limit: int = 0,
    ) -> GetKlineResponse:
        request = GetKlineRequest()
        request.market = market
        if from_ is not None:
            request.from_ = from_
        if to is not None:
            request.to = to
        request.resolution = resolution
        request.limit = limit

        return await self._unary_unary(
            "/api.Api/GetKline",
            request,
            GetKlineResponse,
        )

    async def get_orderbook(
        self, *, market: str = "", limit: int = 0, project: "Project" = 0
    ) -> GetOrderbookResponse:
        request = GetOrderbookRequest()
        request.market = market
        request.limit = limit
        request.project = project

        return await self._unary_unary(
            "/api.Api/GetOrderbook",
            request,
            GetOrderbookResponse,
        )

    async def get_market_depth(
        self, *, market: str = "", limit: int = 0, project: "Project" = 0
    ) -> GetMarketDepthResponse:
        request = GetMarketDepthRequest()
        request.market = market
        request.limit = limit
        request.project = project

        return await self._unary_unary(
            "/api.Api/GetMarketDepth",
            request,
            GetMarketDepthResponse,
        )

    async def get_trades(
        self, *, market: str = "", limit: int = 0, project: "Project" = 0
    ) -> GetTradesResponse:
        request = GetTradesRequest()
        request.market = market
        request.limit = limit
        request.project = project

        return await self._unary_unary(
            "/api.Api/GetTrades",
            request,
            GetTradesResponse,
        )

    async def get_quotes(
        self,
        *,
        in_token: str = "",
        out_token: str = "",
        in_amount: float = 0,
        slippage: float = 0,
        limit: int = 0,
        projects: List["Project"] = [],
    ) -> GetQuotesResponse:
        request = GetQuotesRequest()
        request.in_token = in_token
        request.out_token = out_token
        request.in_amount = in_amount
        request.slippage = slippage
        request.limit = limit
        request.projects = projects

        return await self._unary_unary(
            "/api.Api/GetQuotes",
            request,
            GetQuotesResponse,
        )

    async def get_server_time(self) -> GetServerTimeResponse:
        """system API"""

        request = GetServerTimeRequest()

        return await self._unary_unary(
            "/api.Api/GetServerTime",
            request,
            GetServerTimeResponse,
        )

    async def get_recent_block_hash(self) -> GetRecentBlockHashResponse:
        request = GetRecentBlockHashRequest()

        return await self._unary_unary(
            "/api.Api/GetRecentBlockHash",
            request,
            GetRecentBlockHashResponse,
        )

    async def get_account_balance(
        self, *, owner_address: str = ""
    ) -> GetAccountBalanceResponse:
        """account endpoints"""

        request = GetAccountBalanceRequest()
        request.owner_address = owner_address

        return await self._unary_unary(
            "/api.Api/GetAccountBalance",
            request,
            GetAccountBalanceResponse,
        )

    async def get_token_accounts(
        self, *, owner_address: str = ""
    ) -> GetTokenAccountsResponse:
        request = GetTokenAccountsRequest()
        request.owner_address = owner_address

        return await self._unary_unary(
            "/api.Api/GetTokenAccounts",
            request,
            GetTokenAccountsResponse,
        )

    async def post_order(
        self,
        *,
        owner_address: str = "",
        payer_address: str = "",
        market: str = "",
        side: "Side" = 0,
        type: List[common.OrderType] = [],
        amount: float = 0,
        price: float = 0,
        open_orders_address: str = "",
        client_order_i_d: int = 0,
        project: "Project" = 0,
    ) -> PostOrderResponse:
        """trade endpoints"""

        request = PostOrderRequest()
        request.owner_address = owner_address
        request.payer_address = payer_address
        request.market = market
        request.side = side
        request.type = type
        request.amount = amount
        request.price = price
        request.open_orders_address = open_orders_address
        request.client_order_i_d = client_order_i_d
        request.project = project

        return await self._unary_unary(
            "/api.Api/PostOrder",
            request,
            PostOrderResponse,
        )

    async def post_submit(
        self,
        *,
        transaction: Optional["TransactionMessage"] = None,
        skip_pre_flight: bool = False,
    ) -> PostSubmitResponse:
        request = PostSubmitRequest()
        if transaction is not None:
            request.transaction = transaction
        request.skip_pre_flight = skip_pre_flight

        return await self._unary_unary(
            "/api.Api/PostSubmit",
            request,
            PostSubmitResponse,
        )

    async def post_submit_batch(
        self,
        *,
        entries: List["PostSubmitRequestEntry"] = [],
        submit_strategy: "SubmitStrategy" = 0,
    ) -> PostSubmitBatchResponse:
        request = PostSubmitBatchRequest()
        if entries is not None:
            request.entries = entries
        request.submit_strategy = submit_strategy

        return await self._unary_unary(
            "/api.Api/PostSubmitBatch",
            request,
            PostSubmitBatchResponse,
        )

    async def post_cancel_order(
        self,
        *,
        order_i_d: str = "",
        side: "Side" = 0,
        market_address: str = "",
        owner_address: str = "",
        open_orders_address: str = "",
        project: "Project" = 0,
    ) -> PostCancelOrderResponse:
        request = PostCancelOrderRequest()
        request.order_i_d = order_i_d
        request.side = side
        request.market_address = market_address
        request.owner_address = owner_address
        request.open_orders_address = open_orders_address
        request.project = project

        return await self._unary_unary(
            "/api.Api/PostCancelOrder",
            request,
            PostCancelOrderResponse,
        )

    async def post_cancel_by_client_order_i_d(
        self,
        *,
        client_order_i_d: int = 0,
        market_address: str = "",
        owner_address: str = "",
        open_orders_address: str = "",
        project: "Project" = 0,
    ) -> PostCancelOrderResponse:
        request = PostCancelByClientOrderIDRequest()
        request.client_order_i_d = client_order_i_d
        request.market_address = market_address
        request.owner_address = owner_address
        request.open_orders_address = open_orders_address
        request.project = project

        return await self._unary_unary(
            "/api.Api/PostCancelByClientOrderID",
            request,
            PostCancelOrderResponse,
        )

    async def post_cancel_all(
        self,
        *,
        market: str = "",
        owner_address: str = "",
        open_orders_addresses: List[str] = [],
        project: "Project" = 0,
    ) -> PostCancelAllResponse:
        request = PostCancelAllRequest()
        request.market = market
        request.owner_address = owner_address
        request.open_orders_addresses = open_orders_addresses
        request.project = project

        return await self._unary_unary(
            "/api.Api/PostCancelAll",
            request,
            PostCancelAllResponse,
        )

    async def post_replace_by_client_order_i_d(
        self,
        *,
        owner_address: str = "",
        payer_address: str = "",
        market: str = "",
        side: "Side" = 0,
        type: List[common.OrderType] = [],
        amount: float = 0,
        price: float = 0,
        open_orders_address: str = "",
        client_order_i_d: int = 0,
        project: "Project" = 0,
    ) -> PostOrderResponse:
        request = PostOrderRequest()
        request.owner_address = owner_address
        request.payer_address = payer_address
        request.market = market
        request.side = side
        request.type = type
        request.amount = amount
        request.price = price
        request.open_orders_address = open_orders_address
        request.client_order_i_d = client_order_i_d
        request.project = project

        return await self._unary_unary(
            "/api.Api/PostReplaceByClientOrderID",
            request,
            PostOrderResponse,
        )

    async def post_replace_order(
        self,
        *,
        owner_address: str = "",
        payer_address: str = "",
        market: str = "",
        side: "Side" = 0,
        type: List[common.OrderType] = [],
        amount: float = 0,
        price: float = 0,
        open_orders_address: str = "",
        client_order_i_d: int = 0,
        order_i_d: str = "",
        project: "Project" = 0,
    ) -> PostOrderResponse:
        request = PostReplaceOrderRequest()
        request.owner_address = owner_address
        request.payer_address = payer_address
        request.market = market
        request.side = side
        request.type = type
        request.amount = amount
        request.price = price
        request.open_orders_address = open_orders_address
        request.client_order_i_d = client_order_i_d
        request.order_i_d = order_i_d
        request.project = project

        return await self._unary_unary(
            "/api.Api/PostReplaceOrder",
            request,
            PostOrderResponse,
        )

    async def post_settle(
        self,
        *,
        owner_address: str = "",
        market: str = "",
        base_token_wallet: str = "",
        quote_token_wallet: str = "",
        open_orders_address: str = "",
        project: "Project" = 0,
    ) -> PostSettleResponse:
        request = PostSettleRequest()
        request.owner_address = owner_address
        request.market = market
        request.base_token_wallet = base_token_wallet
        request.quote_token_wallet = quote_token_wallet
        request.open_orders_address = open_orders_address
        request.project = project

        return await self._unary_unary(
            "/api.Api/PostSettle",
            request,
            PostSettleResponse,
        )

    async def post_trade_swap(
        self,
        *,
        project: "Project" = 0,
        owner_address: str = "",
        in_token: str = "",
        out_token: str = "",
        in_amount: float = 0,
        slippage: float = 0,
    ) -> TradeSwapResponse:
        request = TradeSwapRequest()
        request.project = project
        request.owner_address = owner_address
        request.in_token = in_token
        request.out_token = out_token
        request.in_amount = in_amount
        request.slippage = slippage

        return await self._unary_unary(
            "/api.Api/PostTradeSwap",
            request,
            TradeSwapResponse,
        )

    async def get_orders(
        self,
        *,
        market: str = "",
        status: "OrderStatus" = 0,
        side: "Side" = 0,
        types: List[common.OrderType] = [],
        from_: Optional[datetime] = None,
        limit: int = 0,
        direction: "Direction" = 0,
        address: str = "",
        open_orders_address: str = "",
        project: "Project" = 0,
    ) -> GetOrdersResponse:
        request = GetOrdersRequest()
        request.market = market
        request.status = status
        request.side = side
        request.types = types
        if from_ is not None:
            request.from_ = from_
        request.limit = limit
        request.direction = direction
        request.address = address
        request.open_orders_address = open_orders_address
        request.project = project

        return await self._unary_unary(
            "/api.Api/GetOrders",
            request,
            GetOrdersResponse,
        )

    async def get_open_orders(
        self,
        *,
        market: str = "",
        limit: int = 0,
        address: str = "",
        open_orders_address: str = "",
        project: "Project" = 0,
    ) -> GetOpenOrdersResponse:
        request = GetOpenOrdersRequest()
        request.market = market
        request.limit = limit
        request.address = address
        request.open_orders_address = open_orders_address
        request.project = project

        return await self._unary_unary(
            "/api.Api/GetOpenOrders",
            request,
            GetOpenOrdersResponse,
        )

    async def get_order_by_i_d(
        self, *, order_i_d: str = "", market: str = "", project: "Project" = 0
    ) -> GetOrderByIDResponse:
        request = GetOrderByIDRequest()
        request.order_i_d = order_i_d
        request.market = market
        request.project = project

        return await self._unary_unary(
            "/api.Api/GetOrderByID",
            request,
            GetOrderByIDResponse,
        )

    async def get_unsettled(
        self, *, market: str = "", owner_address: str = "", project: "Project" = 0
    ) -> GetUnsettledResponse:
        request = GetUnsettledRequest()
        request.market = market
        request.owner_address = owner_address
        request.project = project

        return await self._unary_unary(
            "/api.Api/GetUnsettled",
            request,
            GetUnsettledResponse,
        )

    async def post_route_trade_swap(
        self,
        *,
        project: "Project" = 0,
        owner_address: str = "",
        steps: List["RouteStep"] = [],
    ) -> TradeSwapResponse:
        request = RouteTradeSwapRequest()
        request.project = project
        request.owner_address = owner_address
        if steps is not None:
            request.steps = steps

        return await self._unary_unary(
            "/api.Api/PostRouteTradeSwap",
            request,
            TradeSwapResponse,
        )

    async def post_perp_order(
        self,
        *,
        project: "Project" = 0,
        owner_address: str = "",
        payer_address: str = "",
        contract: common.PerpContract = 0,
        account_address: str = "",
        position_side: common.PerpPositionSide = 0,
        slippage: float = 0,
        type: common.PerpOrderType = 0,
        amount: float = 0,
        price: float = 0,
        client_order_i_d: int = 0,
    ) -> PostPerpOrderResponse:
        """perp endpoints"""

        request = PostPerpOrderRequest()
        request.project = project
        request.owner_address = owner_address
        request.payer_address = payer_address
        request.contract = contract
        request.account_address = account_address
        request.position_side = position_side
        request.slippage = slippage
        request.type = type
        request.amount = amount
        request.price = price
        request.client_order_i_d = client_order_i_d

        return await self._unary_unary(
            "/api.Api/PostPerpOrder",
            request,
            PostPerpOrderResponse,
        )

    async def get_perp_positions(
        self,
        *,
        project: "Project" = 0,
        owner_address: str = "",
        account_address: str = "",
        contracts: List[common.PerpContract] = [],
    ) -> GetPerpPositionsResponse:
        request = GetPerpPositionsRequest()
        request.project = project
        request.owner_address = owner_address
        request.account_address = account_address
        request.contracts = contracts

        return await self._unary_unary(
            "/api.Api/GetPerpPositions",
            request,
            GetPerpPositionsResponse,
        )

    async def get_open_perp_orders(
        self,
        *,
        project: "Project" = 0,
        owner_address: str = "",
        account_address: str = "",
        contracts: List[common.PerpContract] = [],
    ) -> GetOpenPerpOrdersResponse:
        request = GetOpenPerpOrdersRequest()
        request.project = project
        request.owner_address = owner_address
        request.account_address = account_address
        request.contracts = contracts

        return await self._unary_unary(
            "/api.Api/GetOpenPerpOrders",
            request,
            GetOpenPerpOrdersResponse,
        )

    async def post_cancel_perp_orders(
        self,
        *,
        owner_address: str = "",
        project: "Project" = 0,
        contract: common.PerpContract = 0,
        account_address: str = "",
    ) -> PostCancelPerpOrdersResponse:
        request = PostCancelPerpOrdersRequest()
        request.owner_address = owner_address
        request.project = project
        request.contract = contract
        request.account_address = account_address

        return await self._unary_unary(
            "/api.Api/PostCancelPerpOrders",
            request,
            PostCancelPerpOrdersResponse,
        )

    async def post_cancel_perp_order(
        self,
        *,
        owner_address: str = "",
        project: "Project" = 0,
        contract: common.PerpContract = 0,
        client_order_i_d: int = 0,
        order_i_d: int = 0,
        account_address: str = "",
    ) -> PostCancelPerpOrderResponse:
        request = PostCancelPerpOrderRequest()
        request.owner_address = owner_address
        request.project = project
        request.contract = contract
        request.client_order_i_d = client_order_i_d
        request.order_i_d = order_i_d
        request.account_address = account_address

        return await self._unary_unary(
            "/api.Api/PostCancelPerpOrder",
            request,
            PostCancelPerpOrderResponse,
        )

    async def post_close_perp_positions(
        self,
        *,
        project: "Project" = 0,
        owner_address: str = "",
        contracts: List[common.PerpContract] = [],
    ) -> PostClosePerpPositionsResponse:
        request = PostClosePerpPositionsRequest()
        request.project = project
        request.owner_address = owner_address
        request.contracts = contracts

        return await self._unary_unary(
            "/api.Api/PostClosePerpPositions",
            request,
            PostClosePerpPositionsResponse,
        )

    async def get_perp_orderbook(
        self, *, market: str = "", limit: int = 0, project: "Project" = 0
    ) -> GetPerpOrderbookResponse:
        request = GetPerpOrderbookRequest()
        request.market = market
        request.limit = limit
        request.project = project

        return await self._unary_unary(
            "/api.Api/GetPerpOrderbook",
            request,
            GetPerpOrderbookResponse,
        )

    async def post_create_user(
        self, *, owner_address: str = "", project: "Project" = 0
    ) -> PostCreateUserResponse:
        request = PostCreateUserRequest()
        request.owner_address = owner_address
        request.project = project

        return await self._unary_unary(
            "/api.Api/PostCreateUser",
            request,
            PostCreateUserResponse,
        )

    async def get_user(
        self, *, owner_address: str = "", project: "Project" = 0
    ) -> GetUserResponse:
        request = GetUserRequest()
        request.owner_address = owner_address
        request.project = project

        return await self._unary_unary(
            "/api.Api/GetUser",
            request,
            GetUserResponse,
        )

    async def post_manage_collateral(
        self,
        *,
        owner_address: str = "",
        account_address: str = "",
        amount: float = 0,
        project: "Project" = 0,
        type: common.PerpCollateralType = 0,
        token: common.PerpCollateralToken = 0,
    ) -> PostManageCollateralResponse:
        request = PostManageCollateralRequest()
        request.owner_address = owner_address
        request.account_address = account_address
        request.amount = amount
        request.project = project
        request.type = type
        request.token = token

        return await self._unary_unary(
            "/api.Api/PostManageCollateral",
            request,
            PostManageCollateralResponse,
        )

    async def post_settle_p_n_l(
        self,
        *,
        owner_address: str = "",
        settlee_account_address: str = "",
        contract: common.PerpContract = 0,
        project: "Project" = 0,
    ) -> PostSettlePNLResponse:
        request = PostSettlePNLRequest()
        request.owner_address = owner_address
        request.settlee_account_address = settlee_account_address
        request.contract = contract
        request.project = project

        return await self._unary_unary(
            "/api.Api/PostSettlePNL",
            request,
            PostSettlePNLResponse,
        )

    async def post_settle_p_n_ls(
        self,
        *,
        owner_address: str = "",
        settlee_account_addresses: List[str] = [],
        contract: common.PerpContract = 0,
        project: "Project" = 0,
    ) -> PostSettlePNLsResponse:
        request = PostSettlePNLsRequest()
        request.owner_address = owner_address
        request.settlee_account_addresses = settlee_account_addresses
        request.contract = contract
        request.project = project

        return await self._unary_unary(
            "/api.Api/PostSettlePNLs",
            request,
            PostSettlePNLsResponse,
        )

    async def get_assets(
        self,
        *,
        owner_address: str = "",
        account_address: str = "",
        contract: common.PerpContract = 0,
        project: "Project" = 0,
    ) -> GetAssetsResponse:
        request = GetAssetsRequest()
        request.owner_address = owner_address
        request.account_address = account_address
        request.contract = contract
        request.project = project

        return await self._unary_unary(
            "/api.Api/GetAssets",
            request,
            GetAssetsResponse,
        )

    async def get_perp_contracts(
        self, *, contracts: List[common.PerpContract] = [], project: "Project" = 0
    ) -> GetPerpContractsResponse:
        request = GetPerpContractsRequest()
        request.contracts = contracts
        request.project = project

        return await self._unary_unary(
            "/api.Api/GetPerpContracts",
            request,
            GetPerpContractsResponse,
        )

    async def post_liquidate_perp(
        self,
        *,
        owner_address: str = "",
        settlee_account_address: str = "",
        contract: common.PerpContract = 0,
        amount: float = 0,
        project: "Project" = 0,
    ) -> PostLiquidatePerpResponse:
        request = PostLiquidatePerpRequest()
        request.owner_address = owner_address
        request.settlee_account_address = settlee_account_address
        request.contract = contract
        request.amount = amount
        request.project = project

        return await self._unary_unary(
            "/api.Api/PostLiquidatePerp",
            request,
            PostLiquidatePerpResponse,
        )

    async def get_open_perp_order(
        self,
        *,
        owner_address: str = "",
        account_address: str = "",
        contract: common.PerpContract = 0,
        order_i_d: int = 0,
        client_order_i_d: int = 0,
        project: "Project" = 0,
    ) -> GetOpenPerpOrderResponse:
        request = GetOpenPerpOrderRequest()
        request.owner_address = owner_address
        request.account_address = account_address
        request.contract = contract
        request.order_i_d = order_i_d
        request.client_order_i_d = client_order_i_d
        request.project = project

        return await self._unary_unary(
            "/api.Api/GetOpenPerpOrder",
            request,
            GetOpenPerpOrderResponse,
        )

    async def get_orderbooks_stream(
        self, *, markets: List[str] = [], limit: int = 0, project: "Project" = 0
    ) -> AsyncGenerator[GetOrderbooksStreamResponse, None]:
        """streaming endpoints"""

        request = GetOrderbooksRequest()
        request.markets = markets
        request.limit = limit
        request.project = project

        async for response in self._unary_stream(
            "/api.Api/GetOrderbooksStream",
            request,
            GetOrderbooksStreamResponse,
        ):
            yield response

    async def get_market_depths_stream(
        self, *, markets: List[str] = [], limit: int = 0, project: "Project" = 0
    ) -> AsyncGenerator[GetMarketDepthsStreamResponse, None]:
        request = GetMarketDepthsRequest()
        request.markets = markets
        request.limit = limit
        request.project = project

        async for response in self._unary_stream(
            "/api.Api/GetMarketDepthsStream",
            request,
            GetMarketDepthsStreamResponse,
        ):
            yield response

    async def get_tickers_stream(
        self, *, market: str = "", project: "Project" = 0
    ) -> AsyncGenerator[GetTickersStreamResponse, None]:
        request = GetTickersRequest()
        request.market = market
        request.project = project

        async for response in self._unary_stream(
            "/api.Api/GetTickersStream",
            request,
            GetTickersStreamResponse,
        ):
            yield response

    async def get_trades_stream(
        self, *, market: str = "", limit: int = 0, project: "Project" = 0
    ) -> AsyncGenerator[GetTradesStreamResponse, None]:
        request = GetTradesRequest()
        request.market = market
        request.limit = limit
        request.project = project

        async for response in self._unary_stream(
            "/api.Api/GetTradesStream",
            request,
            GetTradesStreamResponse,
        ):
            yield response

    async def get_order_status_stream(
        self, *, market: str = "", owner_address: str = "", project: "Project" = 0
    ) -> AsyncGenerator[GetOrderStatusStreamResponse, None]:
        request = GetOrderStatusStreamRequest()
        request.market = market
        request.owner_address = owner_address
        request.project = project

        async for response in self._unary_stream(
            "/api.Api/GetOrderStatusStream",
            request,
            GetOrderStatusStreamResponse,
        ):
            yield response

    async def get_recent_block_hash_stream(
        self,
    ) -> AsyncGenerator[GetRecentBlockHashResponse, None]:
        request = GetRecentBlockHashRequest()

        async for response in self._unary_stream(
            "/api.Api/GetRecentBlockHashStream",
            request,
            GetRecentBlockHashResponse,
        ):
            yield response

    async def get_block_stream(self) -> AsyncGenerator[GetBlockStreamResponse, None]:
        request = GetBlockStreamRequest()

        async for response in self._unary_stream(
            "/api.Api/GetBlockStream",
            request,
            GetBlockStreamResponse,
        ):
            yield response

    async def get_quotes_stream(
        self, *, projects: List["Project"] = [], token_pairs: List["TokenPair"] = []
    ) -> AsyncGenerator[GetQuotesStreamResponse, None]:
        request = GetQuotesStreamRequest()
        request.projects = projects
        if token_pairs is not None:
            request.token_pairs = token_pairs

        async for response in self._unary_stream(
            "/api.Api/GetQuotesStream",
            request,
            GetQuotesStreamResponse,
        ):
            yield response

    async def get_pool_reserves_stream(
        self, *, projects: List["Project"] = []
    ) -> AsyncGenerator[GetPoolReservesStreamResponse, None]:
        request = GetPoolReservesStreamRequest()
        request.projects = projects

        async for response in self._unary_stream(
            "/api.Api/GetPoolReservesStream",
            request,
            GetPoolReservesStreamResponse,
        ):
            yield response

    async def get_prices_stream(
        self, *, projects: List["Project"] = [], tokens: List[str] = []
    ) -> AsyncGenerator[GetPricesStreamResponse, None]:
        request = GetPricesStreamRequest()
        request.projects = projects
        request.tokens = tokens

        async for response in self._unary_stream(
            "/api.Api/GetPricesStream",
            request,
            GetPricesStreamResponse,
        ):
            yield response

    async def get_swaps_stream(
        self,
        *,
        projects: List["Project"] = [],
        pools: List[str] = [],
        include_failed: bool = False,
    ) -> AsyncGenerator[GetSwapsStreamResponse, None]:
        request = GetSwapsStreamRequest()
        request.projects = projects
        request.pools = pools
        request.include_failed = include_failed

        async for response in self._unary_stream(
            "/api.Api/GetSwapsStream",
            request,
            GetSwapsStreamResponse,
        ):
            yield response

    async def get_perp_orderbooks_stream(
        self, *, markets: List[str] = [], limit: int = 0, project: "Project" = 0
    ) -> AsyncGenerator[GetPerpOrderbooksStreamResponse, None]:
        """Perp streaming endpoints"""

        request = GetPerpOrderbooksRequest()
        request.markets = markets
        request.limit = limit
        request.project = project

        async for response in self._unary_stream(
            "/api.Api/GetPerpOrderbooksStream",
            request,
            GetPerpOrderbooksStreamResponse,
        ):
            yield response

    async def get_new_perp_orders_stream(
        self, *, markets: List[str] = [], project: "Project" = 0
    ) -> AsyncGenerator[GetNewPerpOrdersStreamResponse, None]:
        request = GetNewPerpOrdersStreamRequest()
        request.markets = markets
        request.project = project

        async for response in self._unary_stream(
            "/api.Api/GetNewPerpOrdersStream",
            request,
            GetNewPerpOrdersStreamResponse,
        ):
            yield response

    async def get_perp_trades_stream(
        self, *, markets: List[str] = [], address: str = "", project: "Project" = 0
    ) -> AsyncGenerator[GetPerpTradesStreamResponse, None]:
        request = GetPerpTradesStreamRequest()
        request.markets = markets
        request.address = address
        request.project = project

        async for response in self._unary_stream(
            "/api.Api/GetPerpTradesStream",
            request,
            GetPerpTradesStreamResponse,
        ):
            yield response
